/**
  ******************************************************************************
  * @ļ    misc.c
  * @    MCD Ӧó
  * @汾    V3.1.0
  * @    06/19/2009
  * @    ļṩĹ̼ (׷ CMSIS<΢ӿڱ׼> ).
  * @    ANSON/sweet1985 Email:airanson110@126.com
  * @    02/07/2009
  ******************************************************************************
  * @
  *
  * ̼ṩͻΪƲƷдĲοĿʹͻԼʱ䡣
  * ͻʹñ̼ڿƷϲĽⷨ뵼幫˾еκֱӵĺͼ
  * ΣҲеκ𺦶⳥
  *
  * <h2><center>&; Ȩ 2009 ⷨ뵼幫˾</center></h2>
  * 汾ѧϰӢԭгӦӢԭΪ׼
  */ 

/*  ------------------------------------------------------------------*/
#include "misc.h"

/*  --------------------------------------------------------------*/
/* ö --------------------------------------------------------------*/

#define AIRCR_VECTKEY_MASK    ((uint32_t)0x05FA0000)

/* ú ------------------------------------------------------------*/
/* ñ ----------------------------------------------------------*/

/* úԭ ------------------------------------------------------*/
/* ú ----------------------------------------------------------*/


/**
  * @  ȼ飺ռȼʹȼ.
  * @  NVIC_PriorityGroup: ȼλ. 
  *                            ȡֵеһ:
  *          NVIC_PriorityGroup_0: ռȼ0λ
  *                                ȼ4λ
  *          NVIC_PriorityGroup_1: ռȼ1λ
  *                                ȼ3λ
  *          NVIC_PriorityGroup_2: ռȼ2λ
  *                                ȼ2λ
  *          NVIC_PriorityGroup_3: ռȼ3λ
  *                                ȼ1λ
  *          NVIC_PriorityGroup_4: ռȼ4λ
  *                                ȼ0λ
  * @  û
  */
void NVIC_PriorityGroupConfig(uint32_t NVIC_PriorityGroup)
{
  /*  */
  assert_param(IS_NVIC_PRIORITY_GROUP(NVIC_PriorityGroup));
  
  /* NVIC_PriorityGroupֵPRIGROUP[10:8]λ */
  SCB->AIRCR = AIRCR_VECTKEY_MASK | NVIC_PriorityGroup;
}

/**
  * @  ͨNVIC_InitStructеָʼΧ豸.
  * @  NVIC_InitStruct: һָָ NVIC Χ豸Ϣ NVIC_InitTypeDef ṹָ.
  * @  û
  */
void NVIC_Init(NVIC_InitTypeDef* NVIC_InitStruct)
{
  uint32_t tmppriority = 0x00, tmppre = 0x00, tmpsub = 0x0F;
  
  /*  */
  assert_param(IS_FUNCTIONAL_STATE(NVIC_InitStruct->NVIC_IRQChannelCmd));
  assert_param(IS_NVIC_PREEMPTION_PRIORITY(NVIC_InitStruct->NVIC_IRQChannelPreemptionPriority));  
  assert_param(IS_NVIC_SUB_PRIORITY(NVIC_InitStruct->NVIC_IRQChannelSubPriority));
    
  if (NVIC_InitStruct->NVIC_IRQChannelCmd != DISABLE)
  {
    /*  IRQ(ж) Ȩ --------------------------------*/    
    tmppriority = (0x700 - ((SCB->AIRCR) & (uint32_t)0x700))>> 0x08;
    tmppre = (0x4 - tmppriority);
    tmpsub = tmpsub >> tmppriority;

    tmppriority = (uint32_t)NVIC_InitStruct->NVIC_IRQChannelPreemptionPriority << tmppre;
    tmppriority |=  NVIC_InitStruct->NVIC_IRQChannelSubPriority & tmpsub;
    tmppriority = tmppriority << 0x04;
        
    NVIC->IP[NVIC_InitStruct->NVIC_IRQChannel] = tmppriority;
    
    /* ʹѡ IRQ(ж) ͨ --------------------------------------*/
    NVIC->ISER[NVIC_InitStruct->NVIC_IRQChannel >> 0x05] =
      (uint32_t)0x01 << (NVIC_InitStruct->NVIC_IRQChannel & (uint8_t)0x1F);
  }
  else
  {
    /* ʧѡ IRQ(ж) ͨ -------------------------------------*/
    NVIC->ICER[NVIC_InitStruct->NVIC_IRQChannel >> 0x05] =
      (uint32_t)0x01 << (NVIC_InitStruct->NVIC_IRQChannel & (uint8_t)0x1F);
  }
}

/**
  * @  λúƫ.
  * @  NVIC_VectTab: ָ RAM  FLASH .
  *                      ȡֵеһ:
  *                      NVIC_VectTab_RAM
  *                      NVIC_VectTab_FLASH
  * @  Offset: ַƫ. ֵ 0x100 .
  * @  û
  */
void NVIC_SetVectorTable(uint32_t NVIC_VectTab, uint32_t Offset)
{ 
  /*  */
  assert_param(IS_NVIC_VECTTAB(NVIC_VectTab));
  assert_param(IS_NVIC_OFFSET(Offset));  
   
  SCB->VTOR = NVIC_VectTab | (Offset & (uint32_t)0x1FFFFF80);
}

/**
  * @  ѡϵͳ͹ģʽ.
  * @  LowPowerMode: ϵͳΪ͹ģʽģʽ.
  *                      ȡֵ֮һ:
  *                      NVIC_LP_SEVONPEND
  *                      NVIC_LP_SLEEPDEEP
  *                      NVIC_LP_SLEEPONEXIT
  * @  NewState: LP ״̬.: ENABLE  DISABLE.
  * @  û
  */
void NVIC_SystemLPConfig(uint8_t LowPowerMode, FunctionalState NewState)
{
  /*  */
  assert_param(IS_NVIC_LP(LowPowerMode));
  assert_param(IS_FUNCTIONAL_STATE(NewState));  
  
  if (NewState != DISABLE)
  {
    SCB->SCR |= LowPowerMode;
  }
  else
  {
    SCB->SCR &= (uint32_t)(~(uint32_t)LowPowerMode);
  }
}

/**
  * @   SysTick ʱԴ.
  * @  SysTick_CLKSource: ָ SysTick ʱԴ.
  *                           ȡֵ֮һ:
  *          SysTick_CLKSource_HCLK_Div8: SysTick ʱԴΪAHBʱӵ1/8.
  *          SysTick_CLKSource_HCLK:      SysTick ʱԴΪAHBʱ.
  * @  û
  */
void SysTick_CLKSourceConfig(uint32_t SysTick_CLKSource)
{
  /*  */
  assert_param(IS_SYSTICK_CLK_SOURCE(SysTick_CLKSource));
  if (SysTick_CLKSource == SysTick_CLKSource_HCLK)
  {
    SysTick->CTRL |= SysTick_CLKSource_HCLK;
  }
  else
  {
    SysTick->CTRL &= SysTick_CLKSource_HCLK_Div8;
  }
}

/**
  * @}
  */

/**
  * @}
  */

/**
  * @}
  */

/******************* (C) COPYRIGHT 2009 STMicroelectronics *****END OF FILE****/
