#include "stm32f10x.h"
#include "usually.h"


void Init_LED(void);	
void Init_NVIC(void);
void Delay_Ms(uint16_t time);  
void Delay_Us(uint16_t time);


int main(void)
{
	SystemInit();				
	Init_NVIC();	
	Init_LED();					
	while(1)
	{  	
		LED1= 1;LED2=LED3=0;    
		Delay_Ms(200);		
		LED2= 1;LED1=LED3=0;	
		Delay_Ms(200);		
		LED3= 1;LED1=LED2=0;
		Delay_Ms(200);			
	}		  
}






void Init_LED(void)
{
	GPIO_InitTypeDef GPIO_InitStructure;					

	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOD,ENABLE);	
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_6 | GPIO_Pin_12 
	| GPIO_Pin_13; 											
  	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;	   	
  	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;	   	
  	GPIO_Init(GPIOD, &GPIO_InitStructure);				   
}




void Init_NVIC(void)
{ 	
	#ifdef  VECT_TAB_RAM  							

	  NVIC_SetVectorTable(NVIC_VectTab_RAM, 0x0);  	
	#else  

	  NVIC_SetVectorTable(NVIC_VectTab_FLASH, 0x0);  
	#endif
}





void Delay_Ms(uint16_t time)  
{ 
	uint16_t i,j;
	for(i=0;i<time;i++)
  		for(j=0;j<10260;j++);
}





void Delay_Us(uint16_t time)  
{ 
	uint16_t i,j;
	for(i=0;i<time;i++)
  		for(j=0;j<9;j++);
}